
Drupal.BTDonations = {};
Drupal.BTDonations.validateCard = function(event) {
  var validCardNumber = function(num) {
    // Strip out non-numbers
    num = num.replace(/[ .-]/g, "");
    var numeric = /^[0-9]{14,16}$/.test(num);
    if (numeric) {
      // Luhn checksum. Run through the card digits backward.
      var c, n = 0;
      var digits = num.split('').reverse();
      for (i = 0; i < digits.length; i++) {
        c = parseInt(digits[i], 10);
        // Double every other value.
        if (i % 2) {
          c *= 2;
        }
        if (c < 10) {
          n += c;
        }
        else {
          n += c - 9;
        }
      }
      return (n != 0 && n % 10 == 0);
    }
    return false;
  }

  var myform = jQuery(event.currentTarget);
  var cardInput = myform.find("#edit-transaction-credit-card-number-encrypted");
  var cardNumber = cardInput.val();
  var cvvInput = myform.find("#edit-transaction-credit-card-cvv-encrypted");
  var cvv = cvvInput.val();
  var errorMsg = "";
  if (cardNumber === undefined || cardNumber.length === 0 ||  !validCardNumber(cardNumber)) {
    errorMsg = Drupal.t("Invalid credit card number.");
  }
  else if (cvv === undefined || cvv.length === 0 || !/^[0-9]{3,4}$/.test(cvv)) {
    errorMsg = Drupal.t("Invalid security code.");
  }
  if (errorMsg) {
    event.preventDefault();
    cardInput.addClass('error');
    cvvInput.addClass('error');
    alert(errorMsg);
    return false;
  }
};

